import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class Aufgabe2_Kellerautomat {

    /**
     * List of Words which will be calculated by Main Method
     */
    private static String[] words = {"34+62+89+43+***", "31+78+987+1214++7++++++", "34+34+", "34+*", "8+9+7*2*", "57-"};

    /**
     * Calculates all words in Array words
     * @param args no args needed
     */
    public static void main(String[] args) {
        for (String word : words) {
            try {
                calculate(word);
            } catch (IllegalArgumentException e) {
                e.printStackTrace();
            }
        }
    }

    /**
     * Calculates the given Word
     * @param word the word to calculate
     * @return returns the result of the calculation
     * @throws IllegalArgumentException if the word is invalid and can not be caluclated (not accepted words)
     */
    public static int calculate(String word) throws IllegalArgumentException {
        List<Character> wordChars = new ArrayList<>();
        for (char symbol : word.toCharArray()) {
            wordChars.add(symbol);
        }
        ArrayList<Integer> stack = new ArrayList<>();
        stack.add(-1);

        int state = 0; //case 0 - 5 = q0 - q5, case -1 = Abfallzustand
        char operator = '$';
        int firstNumber = 0;
        int secondNumber = 0;
        int result = -1;

        while (wordChars.size() > 0 || state >= 3) {
            char symbol;
            int stackSymbol = stack.remove(stack.size() - 1);
            switch (state) {
                case 0:
                    symbol = wordChars.remove(0);
                    if (!isOperator(symbol) && stackSymbol == -1) {
                        stack.add(-1);
                        stack.add(Character.getNumericValue(symbol));
                        state = 1;
                    } else {
                        dontAccept(word);
                    }
                    break;
                case 1:
                    symbol = wordChars.remove(0);
                    if (!isOperator(symbol) && stackSymbol > -1) {
                        stack.add(stackSymbol);
                        stack.add(Character.getNumericValue(symbol));
                        state = 2;
                    } else {
                        dontAccept(word);
                    }
                    break;
                case 2:
                    symbol = wordChars.remove(0);
                    if (isOperator(symbol) && stackSymbol > -1) {
                        operator = symbol;
                        firstNumber = stackSymbol;
                        state = 3;
                    } else if (!isOperator(symbol) && stackSymbol > -1) {
                        stack.add(stackSymbol);
                        stack.add(Character.getNumericValue(symbol));
                        state = 2;
                    } else if (!isOperator(symbol) && stackSymbol == -1) {
                        stack.add(-1);
                        stack.add(Character.getNumericValue(symbol));
                        state = 2;
                    } else {
                        dontAccept(word);
                    }
                    break;
                case 3:
                    if (stackSymbol > -1) {
                        secondNumber = stackSymbol;
                        stack.add(doOperation(operator, firstNumber, secondNumber));
                        state = 4;
                    } else {
                        dontAccept(word);
                    }
                    break;
                case 4:
                    if (wordChars.size() > 0) {
                        symbol = wordChars.remove(0);
                        if (!isOperator(symbol) && stackSymbol > -1) {
                            stack.add(stackSymbol);
                            stack.add(Character.getNumericValue(symbol));
                            state = 2;
                        } else if (isOperator(symbol) && stackSymbol > -1) {
                            operator = symbol;
                            firstNumber = stackSymbol;
                            state = 3;
                        } else {
                            dontAccept(word);
                        }
                    } else {
                        if (stackSymbol > -1) {
                            result = stackSymbol;
                            state = 5;
                        } else {
                            dontAccept(word);
                        }
                    }
                    break;
                case 5:
                    if (stackSymbol == -1) {
                        stack.add(-1);
                        state = 6;
                    } else {
                        dontAccept(word);
                    }
                    break;
                case 6:
                    accept(word, result);
                    return result;

            }
        }
        dontAccept(word);
        return -1;
    }

    /**
     * Called if word is invalid, throws exception with errormessage
     * @param word the invalid word
     */
    private static void dontAccept(String word) throws IllegalArgumentException{
        throw new IllegalArgumentException("Word: " + word  + "\nnot accepted");
    }

    /**
     * Called if end state is reached, prints the accepted word and result (word is accepted)
     * @param word the accepted word
     * @param result the result
     */
    private static void accept(String word, int result) {
        System.out.println("Word: " + word  + "\naccepted\nResult " + result);
    }

    /**
     * checks if a character is a operator
     * @param symbol character to check
     * @return true if character is a operator, false if not
     */
    private static boolean isOperator(char symbol){
        return symbol == '+' || symbol == '*';
    }

    /**
     * Calculates the result of a operation
     * @param operator the operator
     * @param firstNumber the first number of caluclation
     * @param secondNumber the second number of calculation
     * @return the result of the operation
     * @throws IllegalArgumentException if the operator is invalid and can not be caluclated
     */
    private static int doOperation(char operator, int firstNumber, int secondNumber) {
        if(operator == '+'){
            return firstNumber + secondNumber;
        } else if(operator == '*'){
            return firstNumber * secondNumber;
        }
        throw new IllegalArgumentException("Invalid Operator: " + operator + "\n");
    }

}
